/*
this page only contains comments, instructions and other information. 
No software is or will be written on this page.

-- the software is written by Yvo de Haas
-- latest version written on 29th of june 2013

-- this software is not based in any way, form or chance on any of the existing software. No matter how much I would have wanted to just modify something existing, there was just
   too much difference between the current firmware (mostly for FDM an CNC mills) and the required software for this printer. Now it is too much work to modify when I have 
   existing firmware that functions.

improvements on Beta 0.01
-  Refreshing the Gcode buffer is now done both step related and time related. At slow speeds the buffer should now not deplete. At very high speeds it still might.

-  A target of -0.01mm is no longer ignored. Before, any blank spot in a G1 command would have been filled with -1 to state it was empty. Any -0.01 would have been ignored as 
   it says -1 in the buffer. Now -1 is replaced with 0 if a command is given, but it is -0.01. This way the command won't be ignored.
   
-  Slightly higher new layer speeds that are adjustable. Before the new layer speed was 1500mm/min, it has been raised to 1800mm/min and is now adjustable at the top of the movement 
   tab.

Points that still need fixin'
-  The SD card will right now not be fully reliable. I ends the print, but not always reads the full buffer and in rare cases jams with the laser still on. 
   
-  There currently is no safety regarding the buffer, after a command is read, it will move to the next buffered command. As long as not all buffers are filled, after each X_ or Y_
   step, the software will read another character from the SD card, until the buffer is filled again.
   The problem is that if not enough steps get made to refill the buffer. when the buffer is depleted, the program will likely jam.
   The fix is to add rules that will refill the buffer when it is nearly empty.
   
-  A SD read command will be issued after each step, even when the next (most likely the other axis) step is less than the time required time for a read away. this will cause 
   the next step to be out of sync.
   Fix, the SD only can be read when there is enough time left OR accept that some steps might be up to 200us out of sync. (next will still be on time, the targets are absolute)
   
-  After 71 minutes the micros() will overflow. this will cause movement to temporarily (up to 5ms) speed to the max that the software will require. At the wrong point,
   this will cause the printer to have a layer shift, up to a theoretical full mm.
   Fix: if the timer has too big of a difference, no steps need to be made. 
   
-  The software will try to catch up lost time until the amount of steps required for that time is reached. this catching up is harmless for a few steps, but can cause
   layer shifts when it is too big.
   Fix: reset the timer if a certain value is reached AND/OR Allow for a maximum catchup speed.
   
-  there are currently no movement limiters. the laser can be turned on, even if the laser is not above the printhopper, the printer can run into itself if regulat movements
   and endstops are only used for homing, and ignored in normal use.
   Fix, put all three points in the update movement block as limiters.

User instructions

This is experimental software, not designed for general use. It is fully capable of producing decent prints. there are however a few point that need to be taken in concideration.

-  The SD card is not read for .Gcode, it is read for .txt. As Gcode is nothing more than glorified Gcode, you can just swap the .Gcode for .txt, and the arduino will easily read it.

-  After each print, for safety, reset the printer. This ensure reliable prints every time.

-  Because this software is written around known blocks profided by arduino, and my arduino skills are not limitless, the printers is only capable to read files
   with a set name. the file that prints when you print is called "print.txt". any other file will just be ignored.
   
-  The software does not notice if a SD card has been removed. You can print from the SD card as many times as you like without the system crashing. However if you have printed
   once, the printer has started using the SD card. If you remove the SD card after a print, an re-insert it, you need to reset the printer to be able to print.
   
-  While printing, the software can only add layers. SLS works with a powder hopper, that can only add layers while printing. If the Gcode has up and down movements, the software 
   will only use the up movements. Also, large movements will likely jam the hopper. try to keep Z-layer thickness below a few millimeters.

*/
