unsigned long backlight_countdown = 0;
int stepspeed = 0;
boolean buttonpushed;
boolean menubuttonpushed;
int next_step_reserve = 150; //the time before a new step is made in us.

int X_history, Y_history, Z_history, F_history, E_history;

void update_backlight()
{
  read_shift_regs();
  if(switchUp || switchDown || switchLeft || switchRight || switchEnter || switchMenu1 || switchMenu2 || switchMenu3)
  {
    backlight_countdown = millis() + Backlight_on_time;
    anyswitch = 1;  
  }
  else
  {
    anyswitch = 0;
  }
  if (backlight_countdown < millis())
  {
    digitalWrite(Backlight, 0);
  }
  else
  {
    digitalWrite(Backlight, 1);
  }  
}





void update_interface()
{ 
  switch(menutab)
  {
  case 0:
    lcdclear();
    lcd.setCursor(7,1);
    lcd.print("Y-Tec");
    lcd.setCursor(5,2);
    lcd.print("Focus SLS");
    backlight_countdown = millis() + 20000;
    menutab = 1;
    break;

  case 1:
    if (anyswitch == 1)
    {
      lcdclear();
      menutab = 2;
    }
    break;

  case 2:
    lcdclear();
    lcd.setCursor(0,0);
    lcd.print("Free movement");
    lcd.setCursor(3,1);
    lcd.print("^Y+");
    lcd.setCursor(0,2);
    lcd.print("<X-");
    lcd.setCursor(6,2);
    lcd.print(">X+");
    lcd.setCursor(3,3);
    lcd.print("vY-   o Set speed");
    lcd.setCursor(15,0);
    stepspeed = 0;
    lcd.print("off ");
    menutab = 3;    
    break;

  case 3:
    if(switchEnter)
    {
      if (buttonpushed == 0)
      {
        if (stepspeed == 0)
        {
          stepspeed = 2000;
        }
        else if (stepspeed == 500)
        {
          stepspeed = 0;
        }
        else if (stepspeed == 2000)
        {
          stepspeed = 500;
        }
        buttonpushed = 1;
        lcd.setCursor(15,0);
        if (stepspeed == 500)
        {
          lcd.print("Fast");
        }
        else if (stepspeed == 2000)
        {
          lcd.print("Slow");
        }
        else if (stepspeed == 0)
        {
          lcd.print("off ");
        }
      }    
    }
    else
    {
      buttonpushed = 0;
    } 
    if (switchMenu1)
    {
      if (menubuttonpushed == 0)
      {
        menubuttonpushed = 1;
        menutab = 4;
      }
    }
    else
    { 
      menubuttonpushed = 0;
    }


    if (target_reached == 1)
    {
      if (stepspeed > 0)
      {
        pinMode(X_enable,OUTPUT);
        pinMode(Y_enable,OUTPUT);

        if (switchUp && switchDown)
        {
        }
        else if (switchUp)
        {
          digitalWrite(Y_dir, 1);
          Y_target_steps += 10;
          Y_direction = 1;
          Y_speed = stepspeed;
        }
        else if (switchDown)
        {
          digitalWrite(Y_dir, 0);
          Y_target_steps -= 10;
          Y_direction = 0;
          Y_speed = stepspeed;
        }
        if (switchLeft && switchRight)
        {
        }
        else if (switchLeft)
        {
          digitalWrite(X_dir, 1);
          X_target_steps += 10;
          X_direction = 1;
          X_speed = stepspeed;
        }
        else if (switchRight)
        {
          digitalWrite(X_dir, 0);
          X_target_steps -= 10;
          X_direction = 0;
          X_speed = stepspeed;
        }
      }
      else if (stepspeed == 0)
      {
        pinMode(X_enable, INPUT);
        pinMode(Y_enable,INPUT);
      }
      if (switchMenu2)
      {
        menutab = 20;
      }     
      else if (switchMenu3)
      {
        menutab = 50;
      } 
    }
    break;

  case 4:
    pinMode(X_enable, INPUT);
    pinMode(Y_enable,INPUT);
    lcdclear();
    lcd.setCursor(0,0);
    lcd.print("Free movement");
    lcd.setCursor(3,1);
    lcd.print("^F+");
    lcd.setCursor(0,2);
    lcd.print("<B-");
    lcd.setCursor(6,2);
    lcd.print(">B+");
    lcd.setCursor(3,3);
    lcd.print("vF-   o Stop");
    lcd.setCursor(13,1);
    lcd.print("Stopped ");
    menutab = 5; 
    break;

  case 5:
    if (switchMenu1)
    {
      if (menubuttonpushed == 0)
      {
        menubuttonpushed = 1;
        menutab = 6;
      }
    }
    else 
    {
      menubuttonpushed = 0;
    } 
    if (switchMenu2)
    {
      menutab = 20;
    }
    if (switchMenu3)
    {
      menutab = 50;
    }
    if (switchEnter)
    {
      Build_speed = 0;
      Feed_speed = 0;
    }
    if (switchUp)
    {
      Build_speed = 200;
    }
    else if (switchDown)
    {
      Build_speed = -200;
    }
    else if (switchLeft)
    {
      Feed_speed = -200;
    }
    else if (switchRight)
    {
      Feed_speed = 200;
    }
    break;

  case 6:
    pinMode(X_enable, INPUT);
    pinMode(Y_enable,INPUT);
    lcdclear();
    lcd.setCursor(0,0);
    lcd.print("Loose systems");
    lcd.setCursor(5,1);
    lcd.print("^vLASERv^");
    lcd.setCursor(0,2);
    lcd.print("<motA          motB>");
    menutab = 7; 
    break;

  case 7:
    if (switchMenu1)
    {
      if (menubuttonpushed == 0)
      {
        menubuttonpushed = 1;
        menutab = 2;
      }
    }
    else if (switchMenu2)
    {
      menutab = 20;
    }
    else if (switchMenu3)
    {
      menutab = 50;
    }
    else 
    {
      menubuttonpushed = 0;
    } 
    if (switchUp && switchDown)
    {
      digitalWrite(laser, 1);
      laseron = 1;
    }
    else
    {
      digitalWrite(laser, 0);
      laseron = 0;
    }
    if (switchLeft)
    {
      analogWrite(motorA, 50);
    }
    else
    {
      digitalWrite(motorA, 1);
    }
    if (switchRight)
    {
      analogWrite(motorB, 100);
    }
    else
    {
      digitalWrite(motorB, 1);
    }
    break;    





  case 20:
    pinMode(X_enable, INPUT);
    pinMode(Y_enable,INPUT);
    lcdclear();
    lcd.setCursor(0,0);
    lcd.print("Set movement");
    lcd.setCursor(4,1);
    lcd.print("^Home");
    lcd.setCursor(4,3);
    lcd.print("vTo 0");
    lcd.setCursor(8,2);
    lcd.print(">new L");
    lcd.setCursor(14,3);
    lcd.print("o Mode");
    menutab = 21;
    break;

  case 21:
    if (target_reached == 1)
    {
      if (switchMenu1)
      {
        menutab = 2;
        menubuttonpushed = 1;
      }
      else if (switchMenu3)
      {
        menutab = 50;
      }
      else if (switchEnter && buttonpushed == 0)
      {
        menutab = 24;
        buttonpushed = 1;
      }
      else if (switchEnter)
      {
      }
      else if (switchUp)
      {
        menutab = 22;
      }
      else if (switchDown)
      {
        if (homed)
        {
          pinMode(X_enable,OUTPUT);
          pinMode(Y_enable,OUTPUT);
          set_target(0,0,0,1500,0);
        }
      }
      else if (switchRight)
      {
        new_layer(50);
      }
      else 
      {
        buttonpushed = 0;
      }
    }
    break;  

  case 22:
    lcdclear();
    lcd.setCursor(3,0);
    lcd.print("Are you sure?");
    lcd.setCursor(2,1);
    lcd.print("<Yes      No>");
    menutab = 23;
    break;

  case 23:
    if (switchRight)
    {
      menutab = 20;
    }
    else if (switchLeft)
    {
      HomeXY();
      menutab = 20;
    }
    break;

  case 24:
    pinMode(X_enable, INPUT);
    pinMode(Y_enable,INPUT);
    lcdclear();
    lcd.setCursor(0,0);
    lcd.print("Set movement");
    lcd.setCursor(4,1);
    lcd.print("^TL");
    lcd.setCursor(4,3);
    lcd.print("vBR");
    lcd.setCursor(0,2);
    lcd.print("<BL");
    lcd.setCursor(8,2);
    lcd.print(">TR"); 
    lcd.setCursor(14,3);
    lcd.print("o Mode");   
    buttonpushed = 1;
    menutab = 25;
    break;

  case 25:
    if (target_reached == 1)
    {
      if (switchEnter && buttonpushed == 0)
      {
        menutab = 20;
        buttonpushed = 1;
      }
      else if (switchEnter)
      {
      }
      else
      {
        buttonpushed = 0;
      }
      if (homed == 1)
      {
        if (switchUp)
        {
          pinMode(X_enable,OUTPUT);
          pinMode(Y_enable,OUTPUT);
          int tempX = X_printbed_size_mm * 50;
          int tempY = Y_printbed_size_mm * 50;
          set_target(tempX,tempY,0,1500,0);
        }
        else if (switchDown)
        {
          pinMode(X_enable,OUTPUT);
          pinMode(Y_enable,OUTPUT);
          int tempX = X_printbed_size_mm * -50;
          int tempY = Y_printbed_size_mm * -50;
          set_target(tempX,tempY,0,1500,0);
        }
        else if (switchLeft)
        {
          pinMode(X_enable,OUTPUT);
          pinMode(Y_enable,OUTPUT);
          int tempX = X_printbed_size_mm * 50;
          int tempY = Y_printbed_size_mm * -50;
          set_target(tempX,tempY,0,1500,0);
        }
        else if (switchRight)
        {
          pinMode(X_enable,OUTPUT);
          pinMode(Y_enable,OUTPUT);
          int tempX = X_printbed_size_mm * -50;
          int tempY = Y_printbed_size_mm * 50;
          set_target(tempX,tempY,0,1500,0);
        }
      }
      if (switchMenu1)
      {
        menutab = 2;
        menubuttonpushed = 1;
      }
      else if (switchMenu3)
      {
        menutab = 50;
      }
    }
    break;

  case 48:
    //pinMode(X_enable, INPUT); // enable after end print offset fix
    //pinMode(Y_enable,INPUT); // enable after end print offset fix
    lcdclear();
    lcd.setCursor(3,1);
    lcd.print("Done printing");
    lcd.setCursor(4,2);
    lcd.print("o Continue o");
    menutab = 49;
    break;

  case 49:
    if (switchEnter)
    {
      menutab = 50;
    }
    break;



  case 50:
    pinMode(X_enable, INPUT);
    pinMode(Y_enable,INPUT);
    lcdclear();
    lcd.setCursor(0,0);
    lcd.print("Print menu"); 
    lcd.setCursor(2,2);
    lcd.print("^ Start Print ^"); 
    lcd.setCursor(2,3);
    lcd.print("v             v");
    menutab = 51;
    break;


  case 51:
    if (switchMenu1)
    {
      menutab = 2;
      menubuttonpushed = 1;
    }
    else if (switchMenu2)
    {
      menutab = 20;
    }
    if (switchUp && switchDown)
    {
      menutab = 98;
    }
    break;


  case 70:
    pinMode(X_enable, INPUT); 
    pinMode(Y_enable,INPUT); 
    lcdclear();
    lcd.setCursor(1,1);
    lcd.print("laser out of range");
    lcd.setCursor(4,2);
    lcd.print("o Continue o");
    menutab = 71;
    break;

  case 71:
    if (switchEnter)
    {
      menutab = 50;
    }
    break;


  case 98:
    pinMode(X_enable, INPUT);
    pinMode(Y_enable,INPUT);
    lcdclear();
    lcd.setCursor(3,0);
    lcd.print("Is SD inserted"); 
    lcd.setCursor(2,2);
    lcd.print("< Start Print >"); 
    lcd.setCursor(5,3);
    lcd.print("o Back o");
    menutab = 99;
    break;

  case 99:
    if (switchEnter)
    {
      menutab = 50;
    }
    if (switchLeft && switchRight)
    {
      menutab = 100;
      printing = 1;
      homed = 0;
    }
    break;






    //case 100, printing menu, all of the comands regarding printing are stored here-------------------------------------------------------------vvv
  case 100:

    //enable the motors
    pinMode(X_enable,OUTPUT);
    pinMode(Y_enable,OUTPUT);
    HomeXY();
    X_history = 0;
    Y_history = 0;
    Z_history = 0;
    F_history = 1000;
    E_history = 0;
    Z_pos_10um = 0;

    while (homed == 0) //home de assen
    {


      if (switchDown)
      {
        homed = 1;
        printing = 0;
        menutab = 50;
      }
    }

    lcdclear();
    lcd.setCursor(5,0);
    lcd.print("Printing");
    lcd.setCursor(0,1);
    lcd.print("Layer     of");
    lcd.setCursor(4,3);
    lcd.print("ov> Interupt");

    if (SDfound == 0) //initialize the SD card, but only if it hasn't initiated before;
    {
      if (!SD.begin(53))
      {
        return;
      }
    }
    SDfound = 1;

    myFile = SD.open("print.txt");

    if (myFile)
    {
      lcd.setCursor(0,2);
      lcd.print("print.txt");
    }
    else
    {
      lcd.setCursor(0,2);
      lcd.print("Error");
    }

    //vul in eerste instantie de buffer
    bufferloc = 0;
    bufferread = 0;


    while (bufferloc < buffersize - 2)
    {
      identify();
      if (newSDline == 1)
      {
        bufferloc++;
        newSDline = 0;
      }
    }

    pinMode(X_enable,OUTPUT);
    pinMode(Y_enable,OUTPUT);

    bufferloc = 0;


    while (printing == 1 && homed == 1) // everything that is in actual printing
    {
      update_backlight();
      if (switchEnter && switchDown && switchRight) // interupt combination, will fully interupt the print, currently no restart posible after interupt
      {
        menutab = 50;
        printing = 0;
        myFile.close();
        digitalWrite(laser, 0);
        laseron = 0;
      }
      if (laser_out_of_print_range == 1) // interupt combination, will fully interupt the print, currently no restart posible after interupt //procedure is never called
      {
        menutab = 70;
        printing = 0;
        myFile.close();
        digitalWrite(laser, 0);
        laseron = 0;
      }

      if (myFile.available()) // as long as there is a file available from the SD card, read from it and fill buffer
      {
        //time based buffer refill only works for diagonal motion. With X or Y only movements one of the targets is way behind the micros()
        if (X_stepped == 1 || Y_stepped == 1 || ((X_target_time > micros() + next_step_reserve) && (Y_target_time > micros() + next_step_reserve))) //when a step is made or there is still time left
        {
          X_stepped = 0;
          Y_stepped = 0;

          if (bufferloc != bufferread) // deze moet bij een stap in worden geknutseld
          {
            identify();
            if (newSDline == 1)
            {
              bufferloc++;
              if (bufferloc >= buffersize)
              {
                bufferloc = 0;
              }
              newSDline = 0;
            }
          }
        }
      }
      else if (target_reached == 0) // and the target is not reached
      {
      }
      // while there is information left in the buffer, run remaining buffer. (one of the requirements might jam the firmware, recheck)
      else if (bufferloc != 0 && bufferloc - 1 != bufferread)
      {
      }
      else if (bufferloc == 0 && buffersize - 2 != bufferread)
      {
      }
      else
      {
        // if all requirements are met, shut down printfile
        printing = 0;
        menutab = 48; 
        myFile.close();
        backlight_countdown = millis() + 60000;// put on backlight after print
        digitalWrite(laser, 0);
        laseron = 0;
      } 




      if (target_reached == 1)
      {
        if (Gcodebuffer[bufferread][0] == 2) // in case of G1 (move) code
        {
          // check for hollow commands that contain no X and Y movements and thus don't cause a buffering movement
          // fill the buffer aditionally for these hollow movements
          if (Gcodebuffer[bufferread][1] == -1 && Gcodebuffer[bufferread][2] == -1)
          {
            if (myFile.available()) // at every G92 command, fill the buffer 
            {
              while (bufferloc != bufferread) // if the buffer isn't full fill buffer completely
              {
                identify();
                if (newSDline == 1)
                {
                  bufferloc++;
                  if (bufferloc >= buffersize)
                  {
                    bufferloc = 0;
                  }
                  newSDline = 0;
                }
              } 
            }
          }

          // block for filling in unfilled buffer slots with the previous history value
          if (Gcodebuffer[bufferread][1] != -1) // if no value is given, replace value with history value
          {
            X_history = Gcodebuffer[bufferread][1];
          }
          else 
          {
            Gcodebuffer[bufferread][1] = X_history;
          }

          if (Gcodebuffer[bufferread][2] != -1)
          {
            Y_history = Gcodebuffer[bufferread][2];
          }
          else 
          {
            Gcodebuffer[bufferread][2] = Y_history;
          }

          if (Gcodebuffer[bufferread][3] != -1)
          {
            Z_history = Gcodebuffer[bufferread][3];
          }
          else 
          {
            Gcodebuffer[bufferread][3] = Z_history;
          }

          if (Gcodebuffer[bufferread][4] != -1)
          {
            F_history = Gcodebuffer[bufferread][4];
          }
          else 
          {
            Gcodebuffer[bufferread][4] = F_history;
          }

          if (Gcodebuffer[bufferread][5] != -1)
          {
            E_history = Gcodebuffer[bufferread][5];
          }
          else 
          {
            Gcodebuffer[bufferread][5] = E_history;
          }
          // if after history replacement the speed is to high, lower the speed to the maximum acceptable level
          if (Gcodebuffer[bufferread][4] > Max_feedrate)
          {
            Gcodebuffer[bufferread][4] = Max_feedrate;
          }


          //after all the checking, initial movement and safety including history, set the new target.
          set_target(Gcodebuffer[bufferread][1], Gcodebuffer[bufferread][2], Gcodebuffer[bufferread][3], Gcodebuffer[bufferread][4], Gcodebuffer[bufferread][5]);
        }



        else if (Gcodebuffer[bufferread][0] == 93) // in case of G92 (set axis to) code
        {
          // this command is a slow command, always before a move, and officially an unbuffered comand in many firmwares. 
          // the buffer will be replenished in this comand, which might take a few milliseconds at most
          // the lase will be turned off, considering all the previous points, just to be sure.
          laseron = 0;
          digitalWrite(laser, 0); 
          if (myFile.available()) // at every G92 command, fill the buffer 
          {
            while (bufferloc != bufferread) // if the buffer isn't full fill buffer completely
            {
              identify();
              if (newSDline == 1)
              {
                bufferloc++;
                if (bufferloc >= buffersize)
                {
                  bufferloc = 0;
                }
                newSDline = 0;
              }
            } 
          }



          if (Gcodebuffer[bufferread][1] != -1) // if no value is given, replace value with history value
          {
            int tempX = map(Gcodebuffer[bufferread][1],0,100,0,XY_steps_per_mm);
            X_pos_steps = tempX;
            X_pos_steps = tempX;
          }
          if (Gcodebuffer[bufferread][2] != -1)
          {
            int tempY = map(Gcodebuffer[bufferread][2],0,100,0,XY_steps_per_mm);
            Y_pos_steps = tempY;
            Y_pos_steps = tempY;
          }            
          if (Gcodebuffer[bufferread][3] != -1)
          {
            Z_pos_10um = Gcodebuffer[bufferread][3];
          }                        
          if (Gcodebuffer[bufferread][5] != -1)
          {
            E_pos_10um = Gcodebuffer[bufferread][5];
          }         
        }
        bufferread++;
        if (bufferread >= buffersize)
        {
          bufferread = 0;
        }
      }

      // printing procedures

      // als de buffer niet vol is, moet na elke stap er een sd identify commando komen.
      // als er na een identify commando een nieuwe regel klaar is, plaats in buffer.
      // maak na plaatsen in buffer newline laag.

      // als printer op nieuwe bestemming aan komt, lees volgende regel in buffer uit.
      update_movements();

    }
    break;
  }
}




void lcdclear()
{
  lcd.setCursor(0,0);
  lcd.print("                    ");
  lcd.setCursor(0,1);
  lcd.print("                    ");
  lcd.setCursor(0,2);
  lcd.print("                    ");
  lcd.setCursor(0,3);
  lcd.print("                    ");
}
